unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DB, DBTables, DBCtrls, OleCtnrs, ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    OleContainer1: TOleContainer;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    Table1: TTable;
    Button1: TButton;
    Table1SpeciesNo: TFloatField;
    Table1Category: TStringField;
    Table1Common_Name: TStringField;
    Table1SpeciesName: TStringField;
    Table1Lengthcm: TFloatField;
    Table1Length_In: TFloatField;
    Table1Notes: TMemoField;
    Table1Graphic: TGraphicField;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Table1BeforeScroll(DataSet: TDataSet);
    procedure Table1AfterScroll(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  Signature: Integer = -525465623;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.Button1Click(Sender: TObject);
//New Object
begin
    OleContainer1.InsertObjectDialog;
end;

procedure TForm1.Button4Click(Sender: TObject);
//Clear
begin
   //   .
   OleContainer1.DestroyObject;
end;

procedure TForm1.Table1BeforeScroll(DataSet: TDataSet);
var
  Stream: TMemoryStream;
begin
  if OleContainer1.Modified then
  begin
    Stream := nil;
    try
      Stream := TMemoryStream.Create;
      Stream.Write(Signature,SizeOf(Signature));
      if Assigned(OleContainer1.OleObjectInterface) then
        OleContainer1.SaveToStream(Stream);
      Stream.Seek(0, soFromBeginning);
      try
        Table1.Edit;
        TBLOBField(Table1.FieldByName('Graphic')).
           LoadFromStream(Stream);
        Table1.Post;
        OleContainer1.Modified := False;
      except
        Table1.Cancel;
      end;
      finally
        if Assigned(Stream) then Stream.Free;
    end;
  end;
end;

procedure TForm1.Table1AfterScroll(DataSet: TDataSet);
var
  Stream: TMemoryStream;
  N: Integer;
begin
  OleContainer1.DestroyObject;
  Stream := nil;
  try
    Stream := TMemoryStream.Create;
    TBLOBField(Table1.FieldByName('Graphic')).SaveToStream(Stream);
    Stream.Seek(0, soFromBeginning);
    if Stream.Size > 4 then
    begin
       Stream.Read(N, SizeOf(N));
       if N = Signature then
          OleContainer1.LoadFromStream(Stream);
    end;
    OleContainer1.Modified := False;
  finally
    if Assigned(Stream) then Stream.Free;
  end;
end;

end.
